/** -------------------------------------------------
 *                   J-CHOCO
 *   Copyright (C) F. Laburthe, 1999-2003
 * --------------------------------------------------
 *    an open-source Constraint Programming Kernel
 *          for Research and Education
 * --------------------------------------------------
 *
 * file: choco.AbstractEntity.java
 * last modified by Francois 28 aot 2003:14:59:09
 */
package choco;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * An overall root abstract class.
 */
public abstract class AbstractEntity implements Entity {
  /**
     * Reference to the root Logger, an object for logging global trace statements (using the java.util.logging package)
     */

    private static Logger logger = Logger.getLogger("choco");

  /**
   * All objects may be linked to an external object
   */

  public Object hook = null;


  /**
   * The (optimization or decision) problem to which the entity belongs.
   */

  public Problem problem;

  protected AbstractEntity() {
    ;
  }

  protected AbstractEntity(Problem pb) {
    problem = pb;
  }

  /**
   * Retrieves the problem of the entity
   */

  public Problem getProblem() {
    return problem;
  }

  public String pretty() {
    return toString();
  }

}

