// *********************************************
// *                   J-CHOCO                 *
// *   Copyright (c) F. Laburthe, 1999-2003    *
// *********************************************
// * Event-base contraint programming Engine   *
// *********************************************

// CVS Information
// File:               $RCSfile: ContradictionException.java,v $
// Version:            $Revision: 1.1.1.1 $
// Last Modification:  $Date: 2004/05/11 13:51:44 $
// Last Contributor:   $Author: laburthe $

package choco;

import choco.prop.PropagationEngine;

/**
 * An exception thrown when a contradiction achieved.
 */
public class ContradictionException extends Exception {
  /**
   * An exception may have a local cause (the last variable
   * / constraint responsible for the failure)
   */


  /**
   * Contradiction without any identifiable cause
   */

  public ContradictionException(Problem p) {
    PropagationEngine pe = p.getPropagationEngine();
    pe.setNoContradictionCause();
    pe.flushEvents();
  }


  /**
   * Constructs a new contradiction with the specified cause.
   *  @param cause the the last object (variable, constraint) responsible
   * for the failure of propagation
   */

  public ContradictionException(Entity cause) {
    PropagationEngine pe = cause.getProblem().getPropagationEngine();
    pe.setContradictionCause(cause);
    pe.flushEvents();
  }
}

