// *********************************************
// *                   J-CHOCO                 *
// *   Copyright (c) F. Laburthe, 1999-2003    *
// *********************************************
// * Event-base contraint programming Engine   *
// *********************************************

// CVS Information
// File:               $RCSfile: IntConstraint.java,v $
// Version:            $Revision: 1.1.1.1 $
// Last Modification:  $Date: 2004/05/11 13:51:45 $
// Last Contributor:   $Author: laburthe $

package choco.integer;

import choco.Constraint;
import choco.ContradictionException;
import choco.integer.var.IntVarEventListener;
import choco.util.IntIterator;

/**
 * An interface for all implementations of listeners using search variables.
 */
public interface IntConstraint extends Constraint, IntVarEventListener {

  /**
   * <i>Network management:</i>
   *    Accessing the i-th search variable of a constraint.
   *    @param i index of the variable among all search variables in the constraint. Numbering start from 0 on.
   *    @return the variable, or null when no such variable is found
   */

  public IntVar getIntVar(int i);

  public void awakeOnRemovals(int varIdx, IntIterator deltaDomain) throws ContradictionException;

  public void awakeOnBounds(int varIdx) throws ContradictionException;

}
