//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     Explanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.integer.explain;

import choco.palm.PalmProblem;
import choco.palm.integer.explain.AbstractBoundExplanation;
import choco.palm.integer.PalmIntVar;
import choco.Problem;
import choco.Constraint;

import java.util.Set;
import java.util.BitSet;

public class DecSupExplanation extends AbstractBoundExplanation {
  public DecSupExplanation(Problem pb, BitSet explanation, int previousValue, PalmIntVar variable) {
    super(pb);
    this.explanation = explanation;
    this.previousValue = previousValue;
    this.variable = variable;
  }

  public String toString() {
    return this.variable + ".sup < " + this.previousValue + " because " + super.toString();
  }

  public void postUndoRemoval(Constraint removed) {
    this.removeDependencies(removed);
    this.variable.restoreSup(this.previousValue);
  }
}
