package choco.palm.real.constraints;

import choco.real.constraint.MixedEqXY;
import choco.real.RealVar;
import choco.integer.IntVar;
import choco.ContradictionException;
import choco.palm.explain.Explanation;
import choco.palm.explain.PalmConstraintPlugin;
import choco.palm.PalmProblem;
import choco.palm.integer.PalmIntVar;
import choco.palm.integer.PalmIntDomain;
import choco.palm.real.PalmRealVar;
import choco.palm.real.PalmRealInterval;
import choco.palm.real.exp.PalmRealIntervalConstant;
import choco.util.IntIterator;

import java.util.Set;

public class PalmMixedEqXY extends MixedEqXY implements PalmMixedConstraint {
  public PalmMixedEqXY(RealVar v0, IntVar v1) {
    super(v0, v1);
    this.hook = new PalmConstraintPlugin(this);
  }

  protected void updateIInf() {
    Explanation e = ((PalmProblem) getProblem()).makeExplanation();
    ((PalmRealVar) realVar).self_explain(PalmRealInterval.INF, e);
    ((PalmConstraintPlugin) hook).self_explain(e);
    ((PalmIntVar)intVar).updateInf((int) Math.ceil(realVar.getInf()), intIdx, e);
  }

  protected void updateISup() {
    Explanation e = ((PalmProblem) getProblem()).makeExplanation();
    ((PalmRealVar) realVar).self_explain(PalmRealInterval.SUP, e);
    ((PalmConstraintPlugin) hook).self_explain(e);
    ((PalmIntVar)intVar).updateSup((int) Math.floor(realVar.getSup()), intIdx, e);
  }

  protected void updateReal() throws ContradictionException {
    Explanation ei = ((PalmProblem) getProblem()).makeExplanation();
    Explanation es = ((PalmProblem) getProblem()).makeExplanation();
    ((PalmConstraintPlugin) hook).self_explain(ei); ((PalmConstraintPlugin) hook).self_explain(es);
    ((PalmIntVar) intVar).self_explain(PalmIntDomain.INF, ei);
    ((PalmIntVar) intVar).self_explain(PalmIntDomain.SUP, es);
    ((PalmRealVar)realVar).intersect(new PalmRealIntervalConstant(intVar.getInf(), intVar.getSup(), ei, es), realIdx);
  }

  public void awakeOnRemovals(int varIdx, IntIterator deltaDomain) throws ContradictionException {
    this.propagate();
  }

  public void awakeOnRestoreInf(int idx) throws ContradictionException {
    if (idx == 0) awakeOnInf(1);
    else awakeOnInf(0);
  }

  public void awakeOnRestoreSup(int idx) throws ContradictionException {
    if (idx == 0) awakeOnSup(1);
    else awakeOnSup(0);
  }

  public void awakeOnRestoreVal(int idx, int val) throws ContradictionException {
  }

  public void awakeOnRestoreVal(int idx, IntIterator it) throws ContradictionException {
    this.propagate();
  }

  public Set whyIsTrue() {
    return null;
  }

  public Set whyIsFalse() {
    return null;
  }

  public void updateDataStructuresOnConstraint(int idx, int select, int newValue, int oldValue) {
  }

  public void updateDataStructuresOnRestoreConstraint(int idx, int select, int newValue, int oldValue) {
  }

}
