//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     Explanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.real.constraints;

import choco.real.RealInterval;
import choco.real.RealVar;
import choco.real.RealMath;
import choco.Constraint;

/**
 * Splits the variable domain in two sub intervals and make the variable equal the
 * first half (the lower values).
 */
public class PalmSplitLeft extends AbstractPalmSplit {
  /**
   * Creates a constraint splitting the interval to assign the variable to the
   * first half.
   */
  public PalmSplitLeft(RealVar var, RealInterval interval) {
    super(var, interval);
    current = RealMath.firstHalf(interval);
  }

  /**
   * Returns the opposite of this constraint (that is a SplitRight constraint).
   */
  public Constraint negate() {
    return new PalmSplitRight(v0, previous);
  }
}
