//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     Explanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.search;

import choco.Constraint;
import choco.AbstractConstraint;
import choco.palm.search.pathrepair.PathRepairLearn;

import java.util.Collections;
import java.util.List;
import java.util.ArrayList;


public class PalmUnsureRepair extends PalmRepair {

  public Constraint selectDecisionToUndo(choco.palm.explain.Explanation expl) {
      PalmGlobalSearchSolver solver = this.getManager();
      PalmLearn learner = solver.getLearning();
      ArrayList constraints = learner.sortConstraintToUndo(expl);
      int nbCandidates = constraints.size(), idx_ct_out = 0;
      boolean foundCandidate = false;
      AbstractConstraint ct_out = null;
      if (!constraints.isEmpty()) {
        while( idx_ct_out < nbCandidates & !foundCandidate ) {
            ct_out = (AbstractConstraint)constraints.get(idx_ct_out);
            foundCandidate = learner.checkAcceptableRelaxation(ct_out);
            idx_ct_out++;
        }
        //((PathRepairLearn) learner).debugMemory();
        if (foundCandidate) return ct_out;
        else return null;
      } else return null;
  }

}
