package choco.palm.search.pathrepair;



import choco.palm.explain.SearchInfo;

import choco.palm.explain.PalmConstraintPlugin;

import choco.Constraint;



import java.util.Comparator;



/**

 * Created by IntelliJ IDEA.

 * User: Administrateur

 * Date: 15 janv. 2004

 * Time: 14:59:44

 * To change this template use Options | File Templates.

 */

public class PathRepairSearchInfo implements SearchInfo {



    /*

    *  The weigth of a decision constraint appearing in the conflicts in memory

    *  It corresponds to its frequency among the all conflict set weighted by the size of each conflict

    */

    private float weigthInfo = 0;

    private Comparator comparatorInfo;



    public PathRepairSearchInfo() {

        comparatorInfo = new PathRepairComparator();

    }



    public float getWeigth() {

        return weigthInfo;

    }



    public Comparator getComparator() {

        return comparatorInfo;

    }


    public void add(float val) {
        this.weigthInfo += val;
    }

    public void set(float val) {
        this.weigthInfo = val;
    }

    private class PathRepairComparator implements Comparator {



       public int compare(Object o1, Object o2) {

            PalmConstraintPlugin plug1 = (PalmConstraintPlugin) ((Constraint) o1).getPlugIn();

            PalmConstraintPlugin plug2 = (PalmConstraintPlugin) ((Constraint) o2).getPlugIn();

            if (((PathRepairSearchInfo)plug1.getSearchInfo()).getWeigth() > ((PathRepairSearchInfo)plug2.getSearchInfo()).getWeigth())

                return -1;

            else if (((PathRepairSearchInfo)plug1.getSearchInfo()).getWeigth() == ((PathRepairSearchInfo)plug2.getSearchInfo()).getWeigth()) {

            if (plug1.getTimeStamp() > plug2.getTimeStamp())

                return -1;

            else if (plug1.getTimeStamp() < plug2.getTimeStamp())

                return 1;

            else

                return 0;

            } else

            return 1;

        }

    }



}