// *********************************************
// *                   J-CHOCO                 *
// *   Copyright (c) F. Laburthe, 1999-2003    *
// *********************************************
// * Event-base contraint programming Engine   *
// *********************************************

// CVS Information
// File:               $RCSfile: AbstractPropagationEngine.java,v $
// Version:            $Revision: 1.1.1.1 $
// Last Modification:  $Date: 2004/05/11 13:51:50 $
// Last Contributor:   $Author: laburthe $

package choco.prop;

import choco.AbstractEntity;
import choco.Entity;
import choco.Problem;

import java.util.logging.Logger;

/**
 * An abstract class for all implementations of propagation engines.
 */
public abstract class AbstractPropagationEngine extends AbstractEntity implements PropagationEngine {

  /**
   * Storing the cause of the last contradiction.
   */

  protected Entity contradictionCause;

  /**
   * Reference to an object for logging trace statements related to propagation events (using the java.util.logging package)
   */

  protected static Logger logger = Logger.getLogger("choco.prop");

  /**
   * Erase the cause of the last contradiction.
   */

  public void setNoContradictionCause() {
    contradictionCause = null;
  }


  /**
   * Store the cause of the last contradiction.
   */

  public void setContradictionCause(Entity cause) {
    contradictionCause = cause;
  }


  /**
   * Retrieving the cause of the last contradiction.
   */

  public Entity getContradictionCause() {
    return contradictionCause;
  }


  /**
   * Retrieving the overall problem.
   */
  public Problem getProblem() {
    return problem;
  }


  /**
   * Gets the next queue from which a var will be propagated.
   */

  public EventQueue getNextActiveEventQueue() {
    return null;
  }

  protected AbstractPropagationEngine(Problem pb) {
    problem = pb;
  }

}
