// *********************************************
// *                   J-CHOCO                 *
// *   Copyright (c) F. Laburthe, 1999-2003    *
// *********************************************
// * Event-base contraint programming Engine   *
// *********************************************

// CVS Information
// File:               $RCSfile: VarEventListener.java,v $
// Version:            $Revision: 1.1.1.1 $
// Last Modification:  $Date: 2004/05/11 13:51:50 $
// Last Contributor:   $Author: laburthe $

package choco.prop;

import choco.ContradictionException;

import java.util.EventListener;

/**
 * An interface for all the search variable listeners.
 */
public interface VarEventListener extends EventListener {

  /**
   * Reacts to a modification of the variable
   * @param varIndex the index of the variable in the listener
   * @param evt the object representing the change on the variable
   */
  //public void propagateEvent(int varIndex, VarEvent evt)  throws ContradictionException;

  /**
   * propagation on domain revision.
   */
  public void awakeOnVar(int idx) throws ContradictionException;

  /**
   * This function connects a constraint with its variables in several ways.
   *  Note that it may only be called once the constraint
   *  has been fully created and is being posted to a problem.
   *  Note that it should be called only once per constraint.
   */

  public void addListener();

  /**
   * Deactivates this listener in all the variables.
   */

  public void deactivateListener();
  /**
   * Deactivates this listener in all the variables.
   */

  public void deactivateListener(int varIndex);

  /**
   * Activates the listener in all the variables.
   */

  public void activateListener();
  
}
