package choco.search;

import choco.ContradictionException;
import choco.Problem;
import choco.branch.IntBranching;
import choco.branch.IntBranching;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File choco.search.AbstractBinIntBranching.java, last modified by flaburthe 20 oct. 2003 10:59:19 */

public abstract class AbstractBinIntBranching extends AbstractIntBranching {
  public int getFirstBranch(Object x) {
    return 1;
  }

  public int getNextBranch(Object x, int i) {
    assert(i == 1);
    return 2;
  }

  public boolean finishedBranching(Object x, int i) {
    return (i == 2);
  }

  public boolean explore(int n) {
    AbstractGlobalSearchSolver algo = manager;
    Problem pb = algo.problem;
    Object x = selectBranchingObject();
    if (null != x) {
      try {
        return branchOn(x, n);
      } catch (ContradictionException e) {
        return false;
      }
    } else if (null != nextBranching) {
      return ((IntBranching) nextBranching).explore(n);
    } else {
      algo.recordSolution();
      algo.showSolution();
      return algo.stopAtFirstSol;
    }
  }
}
