// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File choco.search.AbstractLargeIntBranching.java, last modified by Francois 22 oct. 2003 00:19:06 */
package choco.search;

import choco.ContradictionException;
import choco.Problem;
import choco.AbstractVar;
import choco.bool.AbstractCompositeConstraint;

public abstract class AbstractLargeIntBranching extends AbstractIntBranching {

  public boolean branchOn(Object x, int n) throws ContradictionException {
    AbstractGlobalSearchSolver algo = manager;
    Problem pb = algo.problem;
    boolean nodeSuccess = false;
    boolean nodeFinished = false;
    int i = getFirstBranch(x);
    algo.newTreeNode();
    try {
      do {
        boolean branchSuccess = false;
        try {
          pb.getPropagationEngine().checkCleanState();
          pb.getEnvironment().worldPush();
          goDownBranch(x, i);
          if (explore(n + 1)) {
            branchSuccess = true;
          }
        } catch (ContradictionException e) {
          ;
        }
        if (!branchSuccess) {
          pb.getEnvironment().worldPop();
        }
        algo.endTreeNode();
        algo.postDynamicCut();
        goUpBranch(x, i);
        if (branchSuccess) {
          nodeSuccess = true;
        }
        if (!finishedBranching(x, i)) {
          i = getNextBranch(x, i);
        } else {
          nodeFinished = true;
        }
      } while (!nodeSuccess && !nodeFinished);
    } catch (ContradictionException e) {
      nodeSuccess = false;
    }
    return nodeSuccess;
  }

}

