package choco.search;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

public class TimeLimit extends AbstractGlobalSearchLimit {
  protected long starth = 0;

  public TimeLimit(AbstractGlobalSearchSolver theSolver, int theLimit) {
      super(theSolver,theLimit);
      unit = "millis.";
    }

   public void reset(boolean first) {
     super.reset(first);
     starth = System.currentTimeMillis();
  }

  public boolean newNode(AbstractGlobalSearchSolver solver) {
    nb = (int) (System.currentTimeMillis() - starth);
    return (nb < nbMax);
  }

  public boolean endNode(AbstractGlobalSearchSolver solver) {
    return true;
  }
}
