package choco.set.search;

import choco.search.AbstractSearchHeuristic;
import choco.integer.search.IValSelector;
import choco.integer.var.IntDomainVar;
import choco.set.SetVar;
import choco.set.var.BitSetEnumeratedDomain;
import choco.util.IntIterator;
import choco.mem.StoredInt;
import choco.Problem;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

public class MinEnv extends AbstractSearchHeuristic implements SetValSelector {

  public MinEnv(Problem pb) {
    problem = pb;
  }

  public int getBestVal(SetVar v) {
    int val = Integer.MIN_VALUE;
    IntIterator it = v.getDomain().getEnveloppeIterator();
    while(it.hasNext()) {
      val = it.next();
      if (!v.isInDomainKernel(val)) break;
    }
    return val;
  }


}
