package choco.test.integer;

import choco.Constraint;
import choco.ContradictionException;
import choco.Problem;
import choco.integer.IntVar;
import junit.framework.TestCase;

import java.util.logging.Logger;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File choco.test.search.LessOrEqualXC.java, last modified by Francois 11 sept. 2003 00:46:25 */

public class LessOrEqualXCTest extends TestCase {
  private static Logger logger = Logger.getLogger("choco.test.search.LessOrEqualXCTest");
  private Problem pb;
  private choco.integer.IntVar x;
  private choco.integer.IntVar y;
  private choco.integer.IntVar z;
  private Constraint c1;
  private Constraint c2;

  protected void setUp() {
    logger.finer("LessOrEqualXC Testing...");
    pb = new Problem();
    x = pb.makeBoundIntVar("X", 1, 5);
    y = pb.makeBoundIntVar("Y", 1, 5);
    c1 = pb.leq(x, 1);
    c2 = pb.leq(y, 2);
  }

  protected void tearDown() {
     c1 = null;
     c2 = null;
     x = null;
     y = null;
     z = null;
     pb = null;
   }

  public void test1() {
    logger.finer("test1");
    try {
      pb.post(c1);
      pb.post(c2);
      pb.propagate();
    } catch (ContradictionException e) {
      assertTrue(false);
    }
    assertTrue(x.isInstantiated());
    assertFalse(y.isInstantiated());
    assertEquals(1, x.getSup());
    assertEquals(2, y.getSup());
    logger.finest("domains OK after first propagate");
    assertTrue(c1.isSatisfied());
    assertEquals(c2.isEntailed(), Boolean.TRUE);
  }
}
