// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File choco.test.search.NotEqualXYCTest.java, last modified by Francois 21 sept. 2003 10:59:44 */

package choco.test.integer;

import choco.Constraint;
import choco.ContradictionException;
import choco.Problem;
import choco.integer.IntVar;
import choco.integer.constraints.NotEqualXYC;
import junit.framework.TestCase;

import java.util.logging.Logger;

public class NotEqualXYCTest extends TestCase {
  private static Logger logger = Logger.getLogger("choco.test.search.NotEqualXCTest");
  private Problem pb;
  private choco.integer.IntVar x;
  private choco.integer.IntVar y;
  private choco.integer.IntVar z;
  private Constraint c1;
  private Constraint c2;

  protected void setUp() {
    logger.fine("NotEqualXYC Testing...");
    pb = new Problem();
    x = pb.makeEnumIntVar("X", 1, 5);
    y = pb.makeEnumIntVar("Y", 1, 5);
    z = pb.makeEnumIntVar("Z", 1, 5);
    c1 = new NotEqualXYC(x, y, -2);
    c2 = new NotEqualXYC(y, z, 1);
  }

  protected void tearDown() {
     c1 = null;
     c2 = null;
     x = null;
     y = null;
     z = null;
     pb = null;
   }

  public void test1() {
    logger.finer("test1");
    try {
      pb.post(c1);
      x.setMax(2);
      y.setVal(3);
      pb.propagate();
      assertFalse(x.canBeInstantiatedTo(1));
      assertTrue(x.isInstantiatedTo(2));
    } catch (ContradictionException e) {
      assertFalse(true);
    }
  }

  public void test2() {
    logger.finer("test2");
    try {
      pb.post(c1);
      pb.post(c2);
      y.setVal(3);
      pb.propagate();
      assertFalse(x.canBeInstantiatedTo(1));
      assertFalse(z.canBeInstantiatedTo(2));
    } catch (ContradictionException e) {
      assertFalse(true);
    }
  }

}
