package chocosamples;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File chocosamples.Sample1.java, last modified by Francois 28 sept. 2003 15:39:24 */

import choco.Constraint;
import choco.ContradictionException;
import choco.Problem;
import choco.integer.IntVar;

import java.util.logging.Logger;

public class Sample1 {
  private static Logger logger = Logger.getLogger("choco");

  //public static void main(String[] args) {
  public static void main(String[] args) {
    logger.fine("CHOCO Sample");
    Problem pb = new Problem();
    choco.integer.IntVar x = pb.makeEnumIntVar("X", 1, 5);
    choco.integer.IntVar y = pb.makeBoundIntVar("Y", 1, 5);
    Constraint c1 = pb.neq(x, 3);
    Constraint c2 = pb.neq(y, 3);
    logger.finer("test1");
    logger.severe("Hello !!!!!");
    try {
      pb.post(c1);
      pb.post(c2);
      pb.propagate();
      assert(!x.canBeInstantiatedTo(3));
      assert(y.canBeInstantiatedTo(3));
      x.remVal(2);
      x.remVal(1);
      pb.propagate();
      assert(x.getInf() == 4);
      y.setMin(3);
      pb.propagate();
      assert(y.getInf() == 4);
    } catch (ContradictionException e) {
      assert(false);
    }
  }
}
